--The gun template, programmed by PegasisVera

function init()
    --This stuff is for you to easily make a gun with. :)
    weaponId = "Shoota" --The ID of the gun used for the game's functionality
    weaponName = "Ork Shoota" --The name of the gun shown to the player
    modelName = "SHOOTA.vox" --This is the model name (located at "MODFOLDER/vox")
    gunSlot = 6 --This is the default slot that the gun goes into
    firepower = 2.5 --How much power the gun has
    maxDistance = 90 --How far the gun shoots
    ammoType = "gun" --What kind of bullet comes out
    ammo = 100 --How much ammo the player spawns with
    firingMode = "auto" --Types: "semi", "auto"
    timeBetweenShots = 0.11 --Time between "auto" shots in seconds
    infiniteAmmo = false --Is the gun infinite?
    penetrationFactor = 0 --How much the gun penetrates (0 means it doesn't penetrate at all)
    shootSnd = LoadSound("MOD/snd/Shootasound.ogg") --The gun shot sound
    emptySnd = LoadSound("tools/dryfire0.ogg") --When your gun is empty, make this sound

    --Positioning for the .vox model
    defaultX = 0.5 --Sideways (where the gun is held horizontally (0 would be centered for aiming down the sights))
    defaultY = -1.2 --Height (where the gun is held vertically)
    defaultZ = -1.2 --Forward (mainly used for recoil)

    --Positioning for the .vox model (when aiming through the sights)
    canAimDownSights = false --This handles if the gun can be aimed down the sights or not
    cameraFov = 90 --This is the target FOV when aiming down sights
    adsX = 0.1 --Sideways (where the gun is held horizontally (0 would be centered for aiming down the sights))
    adsY = -1.1 --Height (where the gun is held vertically)
    --adsZ = -1.2 --Forward (mainly used for recoil) This is probably going to be removed later

    --Positioning for the bullets
    bulletX = 0 --Sideways (this should be where the barrel is found horizontally)
    bulletY = 0 --Height (this should be where the barrel is found vertically)
    bulletZ = -1.1 --Forward (this is where the barrel should be found forward (try to push it in a little))

    --Recoil and aiming stuff
    currentX = defaultX --Where the gun sits horizontally (for aiming)
    currentY = defaultY --Where the gun sits vertically (for aiming)
    currentZ = defaultZ --Where the gun is (mainly used for recoil)
    aiming = false --Tells the game if the gun is currently aiming
    aimLevel = 0 --This isn't to be touched (it handles where the gun is in terms of the lerp to aiming)
    aimSpeed = 0.1 --How fast per frame the gun will aim down the sights
    recoiling = true --Tells the game if the gun is blowing back
    recoilLevel = 0 --How far the recoil currently is blasting (this isn't to be touched)
    recoilMax = 0.15 --The maximum recoil
    recoilSpeed = 0.01 --How fast per frame the recoil goes back to normal
    fired = false --My way of handling a gun being fired in semi-auto mode

    --This stuff should be left alone unless you know what you're doing :)
    timer = 0 --This is for automatic and burst fire weapons, probably best not to touch this. ;)
    SetBool("game.tool." .. weaponId .. ".enabled",true) --This adds the gun to your inventory
    SetInt("game.tool." .. weaponId .. ".ammo",ammo) --This gives you ammo by default
    RegisterTool(weaponId,weaponName,"MOD/vox/" .. modelName,gunSlot) --This tells the game that this is a tool (there's the .vox model file, and the slot it takes up)
end

function lerp(min,max,level) --This is to interpolate things like aiming and such
    return ((max - min) * level + min)
end

function recoil() --This is the recoiling system
    if (recoiling == false) then
        currentZ = lerp(defaultZ,recoilMax,recoilLevel)
    else
        currentZ = lerp(defaultZ,recoilMax,recoilLevel)
    end
    if (recoilLevel > 0 and recoiling == false) then
        recoilLevel = recoilLevel - recoilSpeed
    elseif (recoilLevel >= 0 and recoiling == true and recoilLevel < recoilMax) then
        recoilLevel = recoilLevel + recoilSpeed * 16
        if (recoilLevel >= recoilMax) then
            recoilLevel = recoilMax
            recoiling = false
        end
    else
        recoilLevel = 0
        recoiling = false
    end
end

function tick(dt)
    if GetString("game.player.tool") == weaponId then --If this is selected
        local t = Transform() --This is important transform location stuff
        local pct = GetPlayerCameraTransform()
        local ct = GetCameraTransform()
        -- if (recoilLevel > 0) then --Handle recoil here
        
        recoil()
        t.pos = Vec(currentX,currentY,currentZ) --This is where the gun sits on-screen currently
        SetToolTransform(t)

        --Shooting stuff
        if (InputDown("usetool")) then --When fired
            if (fired == false and firingMode == "semi") then --Check if it has already been fired or not (semi-auto thing)
                if (infiniteAmmo == false and GetInt("game.tool." .. weaponId .. ".ammo") > 0) then --If the gun isn't infinite, use a bullet of its ammo
                    local p = TransformToParentPoint(ct, Vec(bulletX,bulletY,bulletZ))
                    local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1),Vec(0,0,0)))
                    local penetration = 0
                    while (penetration <= penetrationFactor) do --This handles penetration
                        Shoot(p,d,ammoType,firepower,maxDistance)
                        penetration = penetration + 1
                    end
                    PlaySound(shootSnd) --This is the shoot sound
                    SetInt("game.tool." .. weaponId .. ".ammo",GetInt("game.tool." .. weaponId .. ".ammo") - 1)
                    recoiling = true
                else
                    PlaySound(emptySnd) --This is the empty sound
                end
                fired = true
            elseif (timer == 0 and firingMode == "auto") then --This checks if the firing mode is "auto" and hasn't fired yet
                if (infiniteAmmo == false and GetInt("game.tool." .. weaponId .. ".ammo") > 0) then --If the gun isn't infinite, use a bullet of its ammo
                    local p = TransformToParentPoint(ct, Vec(bulletX,bulletY,bulletZ))
                    local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1),Vec(0,0,0)))
                    local penetration = 0
                    while (penetration <= penetrationFactor) do --This handles penetration
                        Shoot(p,d,ammoType,firepower,maxDistance)
                        penetration = penetration + 1
                    end
                    PlaySound(shootSnd) --This is the shoot sound
                    SetInt("game.tool." .. weaponId .. ".ammo",GetInt("game.tool." .. weaponId .. ".ammo") - 1)
                    recoiling = true
                else
                    PlaySound(emptySnd) --This is the empty sound
                end
                timer = timer + dt
            elseif (timer > 0 and timer < timeBetweenShots and firingMode == "auto") then --This checks if the firing mode is "auto" and is waiting to fire
                timer = timer + dt
                if (timer >= timeBetweenShots) then
                    timer = 0
                end
            end
        else --When the trigger is released
            fired = false
        end

        --Aiming stuff
        if (InputDown("grab") and canAimDownSights == true) then --If canAimDownSights is active, the gun will aim down the sights (obviously)
            aiming = true
        elseif (InputDown("grab") == false and canAimDownSights == true) then
            aiming = false
        end
        if (aiming == true) then --This handles the lerp system to move the gun to the ADS spot
            if (aimLevel < 1) then
                aimLevel = aimLevel + aimSpeed
            else
                aimLevel = 1
            end
        else
            if (aimLevel > 0) then
                aimLevel = aimLevel - aimSpeed
            else
                aimLevel = 0
            end
        end
        currentX = lerp(defaultX,adsX,aimLevel)
        currentY = lerp(defaultY,adsY,aimLevel)
    end
end